USE [COWS]
GO
/****** Object:  StoredProcedure [dbo].[updateNRMBPMData]    Script Date: 07/09/2018 13:31:24 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		<Ramesh Ragi>
-- Create date: <09/14/2015>
-- Description:	<Update NRM BPM Data>
-- kh946640 03/26/18 COWS DB Restructuring as columns have been moved from fsa_ordr->fsa_ordr_cpe_line_item table for DualPort project(PJ020783 - CR93)
-- =============================================
--Exec dbo.updateNRMBPMData  12754
ALTER PROCEDURE [dbo].[updateNRMBPMData] 
@ORDR_ID INT
--DECLARE	@ORDR_ID Int = 484351
AS
BEGIN
BEGIN TRY
	SET NOCOUNT ON;
	
	
DECLARE @FTN Varchar(20),
		@PRE_QUAL_NBR Varchar (50)
		 
SELECT @FTN = FTN, @PRE_QUAL_NBR = PRE_QUAL_NBR
	FROM dbo.FSA_ORDR 
	WHERE ORDR_ID = @ORDR_ID
	

		IF OBJECT_ID(N'tempdb..#QDA_V_BPMF_COWS_ORDR',N'U') IS NOT NULL 
						DROP TABLE #QDA_V_BPMF_COWS_ORDR

		CREATE TABLE #QDA_V_BPMF_COWS_ORDR
		(
			M5_ORDR_ID	VARCHAR(20),				--FTN
			VLAN_QTY	VARCHAR(20),				--TPORT_VLAN_QTY (FSA_ORDR)
			NEW_VLAN_ALLC_PCT_QTY	Varchar(100),	--VLAN_PCT_QTY (dbo.ORDR_VLAN) Allocated Percentage
			ETHRNT_ACCS_IND_CD	VARCHAR(50),		--TPORT_ETHRNT_NRFC_INDCR	(FSA_ORDR) Ethernet Interface Indicator
			CNCTR_TYPE_NME	VARCHAR(20),			--TPORT_CNCTR_TYPE_ID (FSA_ORDR) Connector Type Code
			CUST_AUTO_NEG_CD	VARCHAR(5),			--TPORT_CUST_ROUTR_AUTO_NEGOT_CD (FSA_ORDR) Customer Router Auto Negotiation
			CUST_ROUTR_TAGGING_NME	VARCHAR(20),	--TPORT_CUST_ROUTR_TAG_TXT (FSA_ORDR) Connector Router Tagging
			IP_VER_NME	VARCHAR(10),				--TPORT_IP_VER_TYPE_CD (FSA_ORDR) IP Version Type Code
			IPV4_ADD_PRVDR_NME	VARCHAR(8),			--TPORT_IPV4_ADR_PRVDR_CD	(FSA_ORDR) IPv4 Address Provider Code
			IPV6_ADD_PRVDR_NME	VARCHAR(8),			--TPORT_IPV6_ADR_PRVDR_CD	(FSA_ORDR) IPv6 Address Provider Code
			DUAL_STACK_ADD_PRVDR_NME	VARCHAR(8),	--TPORT_DUAL_STK_ADR_PRVDR_TXT	(FSA_ORDR) Dual Stack Address Provider
			SPR_IPV6_QTY	INT,					--TPORT_IPV6_ADR_QTY (FSA_ORDR)	IPv6 Address Quantity
			ENCAP_NME	VARCHAR(20),				--TTRPT_ENCAP_CD 	(FSA_ORDR) Encapsulation Code
			LINK_MGM_PRCOL_NME	VARCHAR(10),		--TPORT_LINK_MGT_PRCOL_TXT	Link Management Protocol
			VNDR_NME	VARCHAR(50),				--INS_VNDR_CD	Vendor Code
			NRFC_PRCOL_NME	VARCHAR(5),				--NRFC_PRCOL_CD (FSA_ORDR)	Interface Protocol Code
			NRFC_TYPE_NME	VARCHAR(50),			--TTRPT_JACK_NRFC_TYPE_CD (FSA_ORDR)	Jack Interface Type Code
			--VNDR_RAW_MRC_IN_CUR_AMT	VARCHAR(25),	--VNDR_RAW_MRC_IN_CUR_AMT (FSA_ORDR),
			VNDR_RAW_MRC_QOT_CUR_AMT	VARCHAR(25),--VNDR_RAW_MRC_QOT_CUR_AMT (FSA_ORDR),
			VNDR_RAW_NRC_QOT_CUR_AMT	VARCHAR(25),--VNDR_RAW_NRC_QOT_CUR_AMT (FSA_ORDR),
			CNVRSN_RT_QTY	VARCHAR(25),			--CNVRSN_RT_QTY (FSA_ORDR),
			MARKUP_PCT_QTY	VARCHAR(25),			--MARKUP_PCT_QTY (FSA_ORDR), 
			TAX_PCT_QTY	VARCHAR(25),				--TAX_PCT_QTY	(FSA_ORDR)
			BEARER_CHG_AMT	VARCHAR(25),			--BEARER_CHG_AMT (FSA_ORDR)
			ADDL_MRC_AMT	VARCHAR(25),			--ADDL_MRC_AMT (FSA_ORDR)
			CALC_RT_MRC_USD_AMT	VARCHAR(25),		--CALC_RT_MRC_USD_AMT (FSA_ORDR)
			CALC_RT_NRC_USD_AMT	VARCHAR(25),		--CALC_RT_NRC_USD_AMT (FSA_ORDR)
			CALC_RT_NRC_IN_CUR_AMT VARCHAR(25),
			CALC_RT_MRC_IN_CUR_AMT VARCHAR(25),
			CUR_NME	VARCHAR(50),						--CUR_NME (FSA_ORDR)	Access Quote Currency
			NOC_TO_NOC_CD	Varchar(3),
			COS_CD			Varchar(100),
			PORT_TYPE_NME	VARCHAR(20),
			VNDR_CXR_CD		VARCHAR(5),
			VNDR_QUOTE_ID	VARCHAR(100),
			HNOFF_TYPE_NME	VARCHAR(100),
			PREQUAL_SITE_ID	VARCHAR(9),
			ETH_ACCS_TYPE_CD	VARCHAR(3),
			PREQUAL_LINE_ITEM_ID VARCHAR(10),
			PREQ_LINE_ITEM_ID_XPIRN_DT DATE,
			DVSTY_TYPE_NME	VARCHAR(20),
			SITE_PHN_NBR	VARCHAR(20)
		)				

		DECLARE @sql nVarchar(max) = ''
		--Select @FTN
		Set @sql = 'Select *
						From OPENQUERY (NRMBPM,''Select M5_ORDR_ID, VLAN_QTY, NEW_VLAN_ALLC_PCT_QTY, 
									ETHRNT_ACCS_IND_CD	,	CNCTR_TYPE_NME	,	CUST_AUTO_NEG_CD	,	
									CUST_ROUTR_TAGGING_NME	,	IP_VER_NME	,	IPV4_ADD_PRVDR_NME	,	
									IPV6_ADD_PRVDR_NME	,	DUAL_STACK_ADD_PRVDR_NME	,	SPR_IPV6_QTY	,	
									ENCAP_NME	,	LINK_MGM_PRCOL_NME	,	VNDR_NME	,	NRFC_PRCOL_NME	,	
									NRFC_TYPE_NME	,	VNDR_RAW_MRC_QOT_CUR_AMT	,	VNDR_RAW_NRC_QOT_CUR_AMT	,	
									CNVRSN_RT_QTY	,	MARKUP_PCT_QTY	,	TAX_PCT_QTY	,	BEARER_CHG_AMT	,	
									ADDL_MRC_AMT	,	CALC_RT_MRC_USD_AMT	,	CALC_RT_NRC_USD_AMT	,	
									CALC_RT_NRC_IN_CUR_AMT ,	CALC_RT_MRC_IN_CUR_AMT ,	CUR_NME	,	
									NOC_TO_NOC_CD	,	COS_CD			,	PORT_TYPE_NME	,	VNDR_CXR_CD		,	
									VNDR_QUOTE_ID	,	HNOFF_TYPE_NME	,	PREQUAL_SITE_ID	,	ETH_ACCS_TYPE_CD	,	
									PREQUAL_LINE_ITEM_ID ,	PREQ_LINE_ITEM_ID_XPIRN_DT ,	DVSTY_TYPE_NME, SITE_PHN_NBR
										From BPMF_OWNER.V_BPMF_COWS_ORDR 
										WHERE M5_ORDR_ID IN ('''''  + @FTN  + ''''')'')'

		--print @sql
		INSERT INTO #QDA_V_BPMF_COWS_ORDR
		Exec sp_executesql @sql	
		
		--Code below added 7/9/2018 to stop multiple VLAN records on change orders when only install
		-- PreQual data is present.  Disc's writing multiple records because PreQual is not there.
		IF ISNULL(@PRE_QUAL_NBR,'') in (SELECT PREQUAL_LINE_ITEM_ID from #QDA_V_BPMF_COWS_ORDR )
			BEGIN		

				DECLARE @NEW_VLAN_ALLC_PCT_QTY Varchar(max) 
				SELECT @NEW_VLAN_ALLC_PCT_QTY = NEW_VLAN_ALLC_PCT_QTY
					FROM #QDA_V_BPMF_COWS_ORDR	

				Select * From #QDA_V_BPMF_COWS_ORDR

				IF ((SELECT COUNT(1) FROM #QDA_V_BPMF_COWS_ORDR) > 0)
					BEGIN
						Update f
							SET 
								--f.TPORT_VLAN_QTY = t.VLAN_QTY,
								--f.TPORT_ETHRNT_NRFC_INDCR = t.ETHRNT_ACCS_IND_CD,
								--f.TPORT_CNCTR_TYPE_ID = t.CNCTR_TYPE_NME,
								--f.TPORT_CUST_ROUTR_AUTO_NEGOT_CD = t.CUST_AUTO_NEG_CD,
								--f.TPORT_CUST_ROUTR_TAG_TXT = t.CUST_ROUTR_TAGGING_NME,
								--f.TPORT_IP_VER_TYPE_CD = t.IP_VER_NME,
								--f.TPORT_IPV4_ADR_PRVDR_CD = t.IPV4_ADD_PRVDR_NME,
								--f.TPORT_IPV6_ADR_PRVDR_CD = t.IPV6_ADD_PRVDR_NME,
								f.TPORT_DUAL_STK_ADR_PRVDR_TXT = t.DUAL_STACK_ADD_PRVDR_NME,
								--f.TPORT_IPV6_ADR_QTY = t.SPR_IPV6_QTY,
								--f.TTRPT_ENCAP_CD = t.ENCAP_NME,
								f.TPORT_LINK_MGT_PRCOL_TXT = t.LINK_MGM_PRCOL_NME,
								--f.INSTL_VNDR_CD = t.VNDR_NME,
								f.NRFC_PRCOL_CD = t.NRFC_PRCOL_NME,
								f.TTRPT_JACK_NRFC_TYPE_CD = t.NRFC_TYPE_NME,
								--f.TPORT_VNDR_RAW_MRC_IN_CUR_AMT = t.VNDR_RAW_MRC_IN_CUR_AMT,
								f.TPORT_VNDR_RAW_NRC_QOT_CUR_AMT = t.VNDR_RAW_NRC_QOT_CUR_AMT,
								f.TPORT_VNDR_RAW_MRC_QOT_CUR_AMT = t.VNDR_RAW_MRC_QOT_CUR_AMT,
								f.TPORT_CNVRSN_RT_QTY = t.CNVRSN_RT_QTY,
								f.TPORT_MARKUP_PCT_QTY = t.MARKUP_PCT_QTY,
								f.TPORT_TAX_PCT_QTY = t.TAX_PCT_QTY,
								f.TPORT_BEARER_CHG_AMT = t.BEARER_CHG_AMT,
								f.TPORT_ADDL_MRC_AMT = t.ADDL_MRC_AMT,
								f.TPORT_CALC_RT_MRC_USD_AMT = t.CALC_RT_MRC_USD_AMT,
								f.TPORT_CALC_RT_NRC_USD_AMT = t.CALC_RT_NRC_USD_AMT,
								f.TPORT_CALC_RT_MRC_IN_CUR_AMT = t.CALC_RT_MRC_IN_CUR_AMT,
								f.TPORT_CALC_RT_NRC_IN_CUR_AMT = t.CALC_RT_NRC_IN_CUR_AMT,
								f.TPORT_CUR_NME = t.CUR_NME,
								--f.TPORT_DIA_NOC_TO_NOC_TXT = t.NOC_TO_NOC_CD,
								f.TPORT_DIA_CLASS_OF_SRVC_TXT = t.COS_CD,
								--f.SPA_ACCS_INDCR_DES = t.PORT_TYPE_NME,
								--f.CXR_ACCS_CD = CASE 
								--					WHEN f.PROD_TYPE_CD IN ('MP','DN','SN','IO','IN') THEN ISNULL(t.VNDR_CXR_CD,f.CXR_ACCS_CD)
								--					ELSE NULL
								--				END,
								f.VNDR_VPN_CD =	CASE 
													WHEN f.PROD_TYPE_CD IN ('MO','IO','IN') THEN ISNULL(t.VNDR_CXR_CD,f.VNDR_VPN_CD)
													ELSE NULL
												END	,
								f.INSTL_VNDR_CD	=	CASE 
														WHEN f.PROD_TYPE_CD IN ('MO','SO','DO','IO','IN') THEN ISNULL(t.VNDR_CXR_CD,f.INSTL_VNDR_CD)
														ELSE NULL
													END	,
								--f.TPORT_VNDR_QUOTE_ID = t.VNDR_QUOTE_ID,
								--f.TTRPT_FBR_HAND_OFF_CD = SUBSTRING(ISNULL(t.HNOFF_TYPE_NME,''),1,50),
								f.TPORT_PREQUAL_SITE_ID = t.PREQUAL_SITE_ID,
								--f.TPORT_ETH_ACCS_TYPE_CD = t.ETH_ACCS_TYPE_CD,
								f.TPORT_PREQUAL_LINE_ITEM_ID = t.PREQUAL_LINE_ITEM_ID,
								f.TPORT_PREQ_LINE_ITEM_ID_XPIRN_DT = t.PREQ_LINE_ITEM_ID_XPIRN_DT,
								f.TPORT_DVSTY_TYPE_NME = t.DVSTY_TYPE_NME
								
							FROM dbo.FSA_ORDR f WITH (ROWLOCK)
						INNER JOIN #QDA_V_BPMF_COWS_ORDR t ON f.FTN = t.M5_ORDR_ID AND f.PRE_QUAL_NBR = t.PREQUAL_LINE_ITEM_ID
						
						Update CPED
							SET CPED.TPORT_VLAN_QTY = t.VLAN_QTY,
								CPED.TPORT_ETHRNT_NRFC_INDCR = t.ETHRNT_ACCS_IND_CD,
								CPED.TPORT_CNCTR_TYPE_ID = t.CNCTR_TYPE_NME,
								CPED.TPORT_CUST_ROUTR_AUTO_NEGOT_CD = t.CUST_AUTO_NEG_CD,
								CPED.TPORT_CUST_ROUTR_TAG_TXT = t.CUST_ROUTR_TAGGING_NME,
								CPED.TPORT_IP_VER_TYPE_CD = t.IP_VER_NME,
								CPED.TPORT_IPV4_ADR_PRVDR_CD = t.IPV4_ADD_PRVDR_NME,
								CPED.TPORT_IPV6_ADR_PRVDR_CD = t.IPV6_ADD_PRVDR_NME,
								CPED.TPORT_IPV6_ADR_QTY = t.SPR_IPV6_QTY,
								CPED.TTRPT_ENCAP_CD = t.ENCAP_NME,
								CPED.SPA_ACCS_INDCR_DES = t.PORT_TYPE_NME,
								CPED.CXR_ACCS_CD = CASE 
													WHEN f.PROD_TYPE_CD IN ('MP','DN','SN','IO','IN') THEN ISNULL(t.VNDR_CXR_CD,CPED.CXR_ACCS_CD)
													ELSE NULL
												END,
								CPED.TPORT_DIA_NOC_TO_NOC_TXT = t.NOC_TO_NOC_CD,
								CPED.TPORT_VNDR_QUOTE_ID = t.VNDR_QUOTE_ID,
								CPED.TTRPT_FBR_HAND_OFF_CD = SUBSTRING(ISNULL(t.HNOFF_TYPE_NME,''),1,50),
								CPED.TPORT_ETH_ACCS_TYPE_CD = t.ETH_ACCS_TYPE_CD
								
							FROM dbo.FSA_ORDR f WITH (ROWLOCK)
							LEFT JOIN dbo.FSA_ORDR_CPE_LINE_ITEM CPED WITH (NOLOCK) ON f.ORDR_ID = CPED.ORDR_ID
							INNER JOIN #QDA_V_BPMF_COWS_ORDR t ON f.FTN = t.M5_ORDR_ID AND f.PRE_QUAL_NBR = t.PREQUAL_LINE_ITEM_ID
						
						IF EXISTS
							(
								SELECT 'X'
									FROM #QDA_V_BPMF_COWS_ORDR
									WHERE ISNULL(SITE_PHN_NBR,'') != '' 
									
							)
							BEGIN
								Update oc
									SET oc.FAX_NBR = t.SITE_PHN_NBR
									FROM #QDA_V_BPMF_COWS_ORDR t WITH (NOLOCK) 
									INNER JOIN dbo.FSA_ORDR fsa WITH (NOLOCK) ON t.M5_ORDR_ID = fsa.FTN AND fsa.PRE_QUAL_NBR = t.PREQUAL_LINE_ITEM_ID
									INNER JOIN dbo.ORDR_CNTCT oc WITH (ROWLOCK) ON	oc.ORDR_ID = fsa.ORDR_ID  
																				AND	oc.CIS_LVL_TYPE = 'H6' 
																				AND oc.CNTCT_TYPE_ID = 17
							END
							
						IF NOT EXISTS (SELECT 'x' from FSA_ORDR where ORDR_ID = @ORDR_ID and PROD_TYPE_CD = 'CP')
							-- Added 7/3/2018 to keep CPE orders from creating VLAN records.  CPE should not have VLAN.
							BEGIN
						
								IF ((SELECT DISTINCT COUNT(NEW_VLAN_ALLC_PCT_QTY) FROM #QDA_V_BPMF_COWS_ORDR WHERE ISNULL(NEW_VLAN_ALLC_PCT_QTY,'0.00') != '0.00') > 0)
									BEGIN
										DECLARE @VlanTbl TABLE (NEW_VLAN_ALLC_PCT_QTY Varchar(20))
										INSERT INTO @VlanTbl
										SELECT * FROM web.ParseCommaSeparatedStrings(@NEW_VLAN_ALLC_PCT_QTY) 
										
									
										INSERT into dbo.ORDR_VLAN (ORDR_ID,VLAN_ID,VLAN_SRC_NME,VLAN_PCT_QTY,CREAT_BY_USER_ID,CREAT_DT,TRMTG_CD)	
										SELECT 	@ORDR_ID,
												'',
												'NRMBP' AS VLAN_SRC_NME,
												NEW_VLAN_ALLC_PCT_QTY, 
												1,
												GETDATE(),
												'0'
												FROM @VlanTbl
									END
							END
							
					END
				
			END



END TRY
BEGIN CATCH
	EXEC dbo.insertErrorInfo
END CATCH
END
